package com.watabou.newquay;

import com.watabou.newquay.Touchscreen.Touch;
import com.watabou.newquay.utils.Signal;

public class TouchArea extends Visual implements Signal.Listener<Touchscreen.Touch> {

	// ,       ,
	//        
	public Visual target;
	
	protected Touch touch = null;
	
	public TouchArea( Visual target ) {
		super( 0, 0, 0, 0 );
		this.target = target;
		
		Touchscreen.event.add( this );
	}
	
	public TouchArea( float x, float y, float width, float height ) {
		super( x, y, width, height );
		this.target = this;
		
		visible = false;
		
		Touchscreen.event.add( this );
	}

	@Override
	public void onSignal( Touch touch ) {
		
		//    ,   ,
		// ,   
		if (!active) {
			return;
		}
		
		boolean hit = touch != null && target.overlapsScreenPoint( (int)touch.start.x, (int)touch.start.y );
		
		if (hit) {
			//     up  down , 
			//    
			Touchscreen.event.cancel();
			
			if (this.touch == null && touch.down) {
				this.touch = touch;
			} else if (this.touch == touch && !touch.down) {
				this.touch = null;
				onClick( touch );
			}
			
		} else {
			
			//   -   , ,
			//   
			
		}
	}
	
	protected void onClick( Touch touch ) {
		//     
	}
	
	@Override
	public void destroy() {
		//      
		Touchscreen.event.remove( this );
		super.destroy();
	}
}
