package com.watabou.newquay;

import java.util.ArrayList;
import java.util.HashMap;

import com.watabou.newquay.utils.PointF;
import com.watabou.newquay.utils.Signal;

import android.view.MotionEvent;

public class Touchscreen {
	
	public static Signal<Touch> event = new Signal<Touch>( true );
	
	public static HashMap<Integer,Touch> pointers = new HashMap<Integer, Touch>();
	
	public static float x;
	public static float y;
	public static boolean touched;

	public static void processTouchEvents( ArrayList<MotionEvent> events ) {
		
		int size = events.size();
		for (int i=0; i < size; i++) {
			
			MotionEvent e = events.get( i );
			x = e.getRawX();
			y = e.getRawY();
			
			Touch touch;
			
			switch (e.getAction()) {
			
			case MotionEvent.ACTION_DOWN:
				touched = true;
				touch = new Touch( x, y );
				pointers.put( e.getPointerId( 0 ), touch );
				event.dispatch( touch );
				break;
				
			case MotionEvent.ACTION_POINTER_DOWN:
				touch = new Touch( x, y );
				pointers.put( e.getPointerId( e.getActionIndex() ), touch );
				event.dispatch( touch );
				break;
				
			case MotionEvent.ACTION_MOVE:
				for (int j=0; j < e.getPointerCount(); j++) {
					pointers.get( e.getPointerId( j ) ).current.set( e.getX( j ), e.getY( j ) );
				}
				event.dispatch( null );
				break;
				
			case MotionEvent.ACTION_POINTER_UP:
				event.dispatch( pointers.remove( e.getPointerId( e.getActionIndex() ) ).up() );
				break;
				
			case MotionEvent.ACTION_UP:
				touched = false;
				event.dispatch( pointers.remove( e.getPointerId( 0 ) ).up() );
				break;
				
			}
			
			e.recycle();
		}
	}
	
	public static class Touch {
		
		public PointF start;
		public PointF current;
		public boolean down;
		
		public Touch( float x, float y ) {
			start = new PointF( x, y );
			current = new PointF( x, y );
			down = true;
		}
		
		public Touch up() {
			down = false;
			return this;
		}
	}

}
