package com.watabou.newquay;

import com.watabou.newquay.utils.GameMath;
import com.watabou.newquay.utils.Point;
import com.watabou.newquay.utils.PointF;

public class Visual extends Gizmo {

	public float x;
	public float y;
	public float width;
	public float height;
	
	public PointF speed;
	public PointF acc;
	public PointF drag;
	
	public float angle;
	public float angularSpeed;
	
	public float parallax = 1f;
	
	public Visual( float x, float y, float width, float height ) {
		this.x = x;
		this.y = y;
		this.width = width;
		this.height = height;
		
		speed = new PointF();
		acc = new PointF();
		drag = new PointF();
	}
	
	@Override
	public void update() {
		updateMotion();
	}
	
	public PointF point() {
		return new PointF( x, y );
	}
	
	public PointF point( PointF p ) {
		x = p.x;
		y = p.y;
		return p;
	}
	
	public Point point( Point p ) {
		x = p.x;
		y = p.y;
		return p;
	}
	
	public PointF center() {
		return new PointF( x + width / 2, y + height / 2 );
	}
	
	public PointF center( PointF p ) {
		x = p.x - width / 2;
		y = p.y - height / 2;
		return p;
	}
	
	protected void updateMotion() {
		float d = (GameMath.speed( speed.x, acc.x, drag.x ) - speed.x) / 2;
		speed.x += d;
		x += speed.x * Game.elapsed;
		speed.x += d;
		
		d = (GameMath.speed( speed.y, acc.y, drag.y ) - speed.y) / 2;
		speed.y += d;
		y += speed.y * Game.elapsed;
		speed.y += d;
		
		angle += angularSpeed * Game.elapsed;
	}
	
	public boolean overlapsPoint( float x, float y ) {
		return x >= this.x && x < this.x + width && y >= this.y && y < this.y + height;
	}
	
	public boolean overlapsScreenPoint( int x, int y ) {
		PointF p = camera().screenToCamera( x, y );
		return overlapsPoint( p.x, p.y );
	}
}
