package com.watabou.newquay.particles;

import com.watabou.newquay.Dot;
import com.watabou.newquay.Game;

public class DotParticle extends Dot {

	protected float lifespan;
	protected float left;
	
	public void reset( float x, float y, int color, float size, float lifespan ) {
		revive();
		
		this.x = x;
		this.y = y;
		
		paint.setColor( color );
		paint.setStrokeWidth( size );
		
		this.left = this.lifespan = lifespan;
	}
	
	@Override
	public void update() {
		super.update();
		
		left -= Game.elapsed;
		paint.setAlpha( (int)(255 * left / lifespan) );
		if (left <= 0) {
			kill();
		}
	}
}
