package com.watabou.newquay.particles;

import com.watabou.newquay.Game;
import com.watabou.newquay.Group;
import com.watabou.newquay.Visual;
import com.watabou.newquay.utils.Random;

public class Emitter extends Group {

	//    
	//   
	protected float x;
	protected float y;	
	protected float width;
	protected float height;
	
	//   ,  
	//     
	protected Visual target;
	
	//     
	protected float interval;
	//  ,    (0 -  )
	protected int quantity;
	
	//  / 
	public boolean on = false;
	
	//    
	protected int count;
	//      
	protected float time;
	
	//      
	protected Factory factory;
	
	public void pos( float x, float y ) {
		pos( x, y, 0, 0 );
	}
	
	public void pos( float x, float y, float width, float height ) {
		this.x = x;
		this.y = y;
		this.width = width;
		this.height = height;
		
		target = null;
	}
	
	public void pos( Visual target ) {
		this.target = target; 
	}
	
	public void burst( Factory factory, int quantity ) {
		start( factory, 0, quantity );
	}
	
	public void pour( Factory factory, float interval ) {
		start( factory, interval, 0 );
	}

	public void start( Factory factory, float interval, int quantity ) {
		
		this.factory = factory;
		
		this.interval = interval;
		this.quantity = quantity;
		
		count = 0;
		time = 0;
		
		on = true;
	}
	
	@Override
	public void update() {
		
		if (on) {
			time += Game.elapsed;
			while (time > interval) {
				time -= interval;
				emit( count );
				if (quantity > 0 && ++count >= quantity) {
					on = false;
					break;
				}
			}
		} else {
			if (countLiving() == 0) {
				kill();
			}
		}
		
		super.update();
	}
	
	protected void emit( int index ) {
		if (target == null) {
			factory.emit( 
				this,
				index,
				x + Random.Float( width ),
				y + Random.Float( height ) );
		} else {
			factory.emit( 
				this,
				index,
				target.x + Random.Float( target.width ),
				target.y + Random.Float( target.height ) );
		}
	}
	
	public interface Factory {

		public void emit( Emitter emitter, int index, float x, float y );
		
	}
}
