package com.watabou.newquay.tweeners;

import com.watabou.newquay.Game;
import com.watabou.newquay.Gizmo;

abstract public class Tweener extends Gizmo {

	public Gizmo target;
	
	public float interval;
	public float elapsed;
	
	public Listener listener;
	
	public Tweener( Gizmo target, float interval ) {
		super();
		
		this.target = target;
		this.interval = interval;
		
		elapsed = 0;
	}
	
	@Override
	public void update() {
		elapsed += Game.elapsed;
		if (elapsed >= interval) {
			updateValues( 1 );
			if (listener != null) {
				listener.onComplete( this );
			}
			kill();
		} else {
			updateValues( elapsed / interval );
		}
	}
	
	abstract protected void updateValues( float progress );
	
	public static interface Listener {
		void onComplete( Tweener tweener );
	}
}
