package com.watabou.newquay.utils;

import com.watabou.newquay.Game;

public class GameMath {

	public static float speed( float speed, float acc, float drag ) {
		return speed( speed, acc, drag, Float.MAX_VALUE );
	}
	
	public static float speed( float speed, float acc, float drag, float limit ) {
		
		if (acc != 0) {
			speed += acc * Game.elapsed;
		} else if (drag != 0) {
			float d = drag * Game.elapsed;
			if (speed - d > 0) {
				speed -= d;
			} else if (speed + d < 0) {
				speed += d;
			} else {
				speed = 0;
			}
		}
		
		if (speed != 0 && limit != Float.MAX_VALUE) {
			if (speed > limit) {
				speed = limit;
			} else if (speed < -limit) {
				speed = -limit;
			}
		}
		
		return speed;
	}
}
